'use strict';

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

const { mocha, Mocha, WebSocket, superagent, location } = window;
const { hostname, port } = location;

// end test if not started within one second
const testTimeout = setTimeout(_asyncToGenerator(function* () {
  yield superagent.post('/end-test').send({ errorMsg: 'No tests detected' });
}), 1000);

const socket = new WebSocket(`ws://${hostname}:${port}/ws`);

socket.addEventListener('open', () => {
  // patch stdout to send strings written to stdout
  Mocha.process.stdout.write = function (data) {
    socket.send(JSON.stringify({
      type: 'stdout',
      data
    }));
  };

  // patch console log to send logs
  const oldConsoleLog = console.log;
  console.log = function (...args) {
    socket.send(JSON.stringify({
      type: 'console',
      data: args
    }));
    oldConsoleLog(...args);
  };

  const runner = mocha.run();

  let testsPassed = true;

  runner.once('fail', () => {
    testsPassed = false;
  });

  runner.once('suite', () => {
    clearTimeout(testTimeout);
  });

  runner.once('end', (() => {
    var _ref2 = _asyncToGenerator(function* (event) {
      yield superagent.post('/end-test').send({
        testsPassed,
        // pass coverage report back to server
        coverageReport: window.__coverage__
      });
    });

    return function (_x) {
      return _ref2.apply(this, arguments);
    };
  })());
});