'use strict';

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

/**
 * loads the .mocha-puppeteer-config file
 */
const path = require('path');
const CONFIG_FILE_NAME = '.mocha-puppeteer-config.js';

const fs = require('fs');
const { R_OK: READABLE } = fs.constants;

const { promisify } = require('bluebird');
const accessAsync = promisify(fs.access);

module.exports = (() => {
  var _ref = _asyncToGenerator(function* ({ startingDirectory, verbose }) {
    let currentDirectory = startingDirectory;

    let parentDirectory;
    let config;
    let configPath;

    while (!configPath && currentDirectory !== parentDirectory) {
      parentDirectory = currentDirectory;

      if (currentDirectory === '/') {
        currentDirectory = '';
      }

      try {
        const path = `${currentDirectory}/${CONFIG_FILE_NAME}`;
        verbose && console.log(`Searching at ${currentDirectory} for a config...`);

        yield accessAsync(`${path}`, READABLE);
        configPath = path;
      } catch (err) {
        verbose && console.error(`No config found in ${currentDirectory}`);
        currentDirectory = path.dirname(currentDirectory);
      }
    }

    if (configPath) {
      try {
        config = require(configPath);
      } catch (err) {
        throw new Error(`Unable to load config at ${configPath}: ${err.stack}`);
      }
    }

    return config;
  });

  function _loadConfig(_x) {
    return _ref.apply(this, arguments);
  }

  return _loadConfig;
})();